/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the SubscriberMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SubscriberMutable{}

// SubscriberMutable struct for SubscriberMutable
type SubscriberMutable struct {
	Email string `json:"email"`
	MutedTypes []string `json:"muted_types,omitempty"`
}

// NewSubscriberMutable instantiates a new SubscriberMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSubscriberMutable(email string) *SubscriberMutable {
	this := SubscriberMutable{}
	this.Email = email
	return &this
}

// NewSubscriberMutableWithDefaults instantiates a new SubscriberMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSubscriberMutableWithDefaults() *SubscriberMutable {
	this := SubscriberMutable{}
	return &this
}

// GetEmail returns the Email field value
func (o *SubscriberMutable) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *SubscriberMutable) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *SubscriberMutable) SetEmail(v string) {
	o.Email = v
}

// GetMutedTypes returns the MutedTypes field value if set, zero value otherwise.
func (o *SubscriberMutable) GetMutedTypes() []string {
	if o == nil || IsNil(o.MutedTypes) {
		var ret []string
		return ret
	}
	return o.MutedTypes
}

// GetMutedTypesOk returns a tuple with the MutedTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SubscriberMutable) GetMutedTypesOk() ([]string, bool) {
	if o == nil || IsNil(o.MutedTypes) {
		return nil, false
	}
	return o.MutedTypes, true
}

// HasMutedTypes returns a boolean if a field has been set.
func (o *SubscriberMutable) HasMutedTypes() bool {
	if o != nil && !IsNil(o.MutedTypes) {
		return true
	}

	return false
}

// SetMutedTypes gets a reference to the given []string and assigns it to the MutedTypes field.
func (o *SubscriberMutable) SetMutedTypes(v []string) {
	o.MutedTypes = v
}

func (o SubscriberMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SubscriberMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["email"] = o.Email
	if !IsNil(o.MutedTypes) {
		toSerialize["muted_types"] = o.MutedTypes
	}
	return toSerialize, nil
}

type NullableSubscriberMutable struct {
	value *SubscriberMutable
	isSet bool
}

func (v NullableSubscriberMutable) Get() *SubscriberMutable {
	return v.value
}

func (v *NullableSubscriberMutable) Set(val *SubscriberMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableSubscriberMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableSubscriberMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSubscriberMutable(val *SubscriberMutable) *NullableSubscriberMutable {
	return &NullableSubscriberMutable{value: val, isSet: true}
}

func (v NullableSubscriberMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSubscriberMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


